#include <stdlib.h>
#include <gtk/gtk.h>
#include <glade/glade.h>
#include <string.h>

#include <libintl.h>
//#define _(String) gettext (String)
#define _(String) dgettext (PACKAGE, String)
#define gettext_noop(String) String
#define N_(String) gettext_noop (String)

#define PACKAGE_VERSION "0.1"
#define PACKAGE_NAME "assoc-gtk"
#define PACKAGE "assoc-gtk"

static GtkWidget *window1 = NULL;
static GladeXML  *xml;

static void on_button1_clicked (GtkWidget *widget, gpointer user_data);
static void on_button2_clicked (GtkWidget *widget, gpointer user_data);
static void on_button3_clicked (GtkWidget *widget, gpointer user_data);
static void on_button4_clicked (GtkWidget *widget, gpointer user_data);
static void on_filechooserbutton1_file_set (GtkWidget *widget, gpointer user_data);

static void
on_button1_clicked (GtkWidget *widget, gpointer user_data) {
    gchar *command = NULL;
    command = g_strconcat(
                  "xdg-mime default ",
                  g_filename_display_basename(
                      gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(glade_xml_get_widget( xml,  "filechooserbutton1")))
                  ),
                  " ",
                  gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget( xml,  "entry1"))),
                  NULL
              );

    g_spawn_command_line_sync(command,NULL,NULL,NULL,NULL);
    GtkWidget *dialog;
    dialog = gtk_message_dialog_new (
                 GTK_WINDOW(window1),
                 GTK_DIALOG_DESTROY_WITH_PARENT,
                 GTK_MESSAGE_INFO,
                 GTK_BUTTONS_OK,
                 "%s",g_strconcat(_("Done! \nThe equivalent console command is:\n\n"),command,NULL)
             );
    gtk_dialog_run (GTK_DIALOG (dialog));
    gtk_widget_destroy (dialog);
    g_free(command);
}

static void
on_button2_clicked (GtkWidget *widget, gpointer user_data) {
    gtk_main_quit();
}

static void
on_button3_clicked (GtkWidget *widget, gpointer user_data) {
    gchar *stdout = NULL, *command = NULL;
    gchar **split = NULL;
    GtkWidget *dialog;

    dialog = gtk_file_chooser_dialog_new(
                 _("Select file"),
                 NULL,
                 GTK_FILE_CHOOSER_ACTION_OPEN,
                 GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                 GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
                 NULL
             );

    if (gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_ACCEPT) {
        command = g_strconcat("xdg-mime query filetype ",gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog)), NULL);

        g_spawn_command_line_sync(command,&stdout,NULL,NULL,NULL);
        split = g_strsplit(stdout,"\n",2);
        gtk_entry_set_text(
            GTK_ENTRY(glade_xml_get_widget (xml, "entry1")),
            g_strconcat(gtk_entry_get_text(GTK_ENTRY(glade_xml_get_widget( xml,  "entry1")))," ", split[0],NULL)
        );
    }
    g_free(command);
    g_free(stdout);
    g_free(split);
    gtk_widget_destroy(GTK_WIDGET(dialog));
}

static void
on_button4_clicked (GtkWidget *widget, gpointer user_data) {
    gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget (xml, "entry1")),"");
}

static void
on_button5_clicked (GtkWidget *widget, gpointer user_data) {
    gchar *stdout = NULL, *selected_desktop_file = NULL, *command = NULL;
    gchar **split = NULL;
    GtkWidget *dialog;

    dialog = gtk_file_chooser_dialog_new(
                 _("Select file"),
                 NULL,
                 GTK_FILE_CHOOSER_ACTION_OPEN,
                 GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
                 GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
                 NULL
             );
    gtk_file_chooser_set_filename(GTK_FILE_CHOOSER(dialog),"/usr/share/applications/");

    if (gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_ACCEPT) {
        selected_desktop_file = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
        if (selected_desktop_file != NULL) {
            command = g_strconcat("/bin/sh -c \"grep 'MimeType=' ",selected_desktop_file," | sed -e 's/.*=//' -e 's/;/ /g'\"", NULL);
            g_spawn_command_line_sync(command,&stdout,NULL,NULL,NULL);
            split = g_strsplit(stdout,"\n",2);
            gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget (xml, "entry1")),g_strdup(split[0]));//g_strdup(stdout)
        }
    }

    gtk_widget_destroy(GTK_WIDGET(dialog));
    g_free(command);
    g_free(stdout);
    g_free(selected_desktop_file);
    g_free(split);
}
//static void
//on_button4_clicked (GtkWidget *widget, gpointer user_data)
//{
//    GtkWidget *dialog = NULL;
//    dialog = gtk_message_dialog_new (GTK_WINDOW (window1), GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_CLOSE, "%s","About");
//    gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
//    gtk_dialog_run (GTK_DIALOG (dialog));
//    gtk_widget_destroy (dialog);
//}

static void
on_filechooserbutton1_file_set (GtkWidget *widget, gpointer user_data) {
//    gchar *stdout = NULL, *selected_desktop_file = NULL, *command = NULL;
//    gchar **split = NULL;
//
//    selected_desktop_file = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(glade_xml_get_widget( xml,  "filechooserbutton1")));
//    if (selected_desktop_file != NULL) {
//        command = g_strconcat("/bin/sh -c \"grep 'MimeType=' ",selected_desktop_file," | sed -e 's/.*=//' -e 's/;/ /g'\"", NULL);
//        g_spawn_command_line_sync(command,&stdout,NULL,NULL,NULL);
//        split = g_strsplit(stdout,"\n",2);
//        gtk_entry_set_text(GTK_ENTRY(glade_xml_get_widget (xml, "entry1")),g_strdup(split[0]));//g_strdup(stdout)
//    }
//    g_free(command);
//    g_free(stdout);
//    g_free(selected_desktop_file);
//    g_free(split);
}

int main (int argc, char *argv[]) {
    gtk_init (&argc, &argv);
    /* load the interface */
    xml = glade_xml_new ("assoc-gtk.glade", NULL, PACKAGE_NAME);

    /* Have the delete event (window close) end the program */
    window1 = glade_xml_get_widget (xml, "window1");

    /* connect the signals in the interface */
    g_signal_connect (G_OBJECT (window1), "delete_event", G_CALLBACK (gtk_main_quit), NULL);
    g_signal_connect (G_OBJECT (glade_xml_get_widget (xml, "button1")), "clicked", G_CALLBACK (on_button1_clicked), NULL);
    g_signal_connect (G_OBJECT (glade_xml_get_widget (xml, "button2")), "clicked", G_CALLBACK (on_button2_clicked), NULL);
    g_signal_connect (G_OBJECT (glade_xml_get_widget (xml, "button3")), "clicked", G_CALLBACK (on_button3_clicked), NULL);
    g_signal_connect (G_OBJECT (glade_xml_get_widget (xml, "button4")), "clicked", G_CALLBACK (on_button4_clicked), NULL);
    g_signal_connect (G_OBJECT (glade_xml_get_widget (xml, "button5")), "clicked", G_CALLBACK (on_button5_clicked), NULL);
    g_signal_connect (G_OBJECT (glade_xml_get_widget (xml, "filechooserbutton1")), "file-set", G_CALLBACK (on_filechooserbutton1_file_set), NULL);

//    glade_xml_signal_autoconnect(xml);

    gtk_file_chooser_set_filename(GTK_FILE_CHOOSER(glade_xml_get_widget(xml, "filechooserbutton1")),"/usr/share/applications/");
    gtk_widget_show_all(window1);
    /* start the event loop */
    gtk_main ();

    return 0;
}
